$(function () {
//    init_timeselector();
});

function cleanSelection() {
    $("#partition-id").find("option").remove();
    $("#encoder-id").find("option").remove();
    $("#sector-id").find("option").remove();
}

var proxy = window.location.href.search("proxy") > 0 ? "/proxy/" : ((hide_query) ? "" : "/")

function availableStatisticsBranches() {
    var my_url = proxy + "device/statistics/" + ending_info;
    console.debug("my_url: : " + my_url);
    $.getJSON(my_url, function (json) {
        console.debug("availableStatisticsBranches: ", json);

        $("#available_statistics_branches").find("option").remove();

        $.each(json.resources, function (i, v) {
            $("#available_statistics_branches").append($('<option>', { value: v, text: v }));
        });
        eventChangeSetup();
    });
}

function get(url, zip, c) {
    return new Promise(function (resolve, reject) {
        var oReq = new XMLHttpRequest();
        oReq.open("GET", url, true);
        oReq.responseType = "arraybuffer";
        oReq.onload = function (oEvent) {
            var arrayBuffer = oReq.response;

            var byteArray = new Uint8Array(arrayBuffer);

            var path = url.replace("\/", "").replace("statistics\/", "");
            //console.debug(path + "\t\t\t\t\t\t\t\t[#]");
            if (path === "index.html") { //move all in local
                //console.debug("* mangle");
                var data = (navigator.userAgent.indexOf('MSIE') !== -1 || navigator.appVersion.indexOf('Trident/') > 0)
                    ? String.fromCharCode.apply(null, byteArray) : new TextDecoder("utf-8").decode(byteArray);
                var dataL = data.replace(new RegExp('\/statistics\/', 'g'), "")
                    .replace(new RegExp('src=\"\/', 'g'), "src=\"")
                    .replace(new RegExp("href=\"\/", 'g'), "href=\"");
                zip.file(path, dataL);
            } else {
                //bin content
                zip.file(path, arrayBuffer/*, { binary: true }*/);
            }
            c += 1;
            resolve(zip);
        };
        oReq.send();
    });
}

function dumpAll() {

    //$.ajaxSetup({async: false});
    var zip = new JSZip();
    var dp = [];

	start_progressbar();
	ongoing_promises = 0;
    dump(zip, proxy + "device/statistics", dp);

	
}

function build_zip_from_jsons(zip, dp) {
	
	dump_data_count = dp.length;
	
	dp.reduce(function (sequence, obj) {

		return sequence.then(function () {
			return $.get(obj.uri, obj, function (data) {
				dump_data_downloaded++;
				update_progressbar("downloading data (" + dump_data_downloaded + "/"+ dump_data_count +")", dump_progress_bar_retrieve_info_max + Math.ceil((dump_progress_bar_retrieve_data_max - dump_progress_bar_retrieve_info_max) * dump_data_downloaded / dump_data_count));
				console.debug(obj.uri);
				zip.file(obj.uri.substring(1), data)
			})
				.fail(function () {
					zip.file(obj.uri.substring(1), "")
					console.debug('woops'); // or whatever
				});
		}).catch(function (err) {
			// handle something
		})
	}, Promise.resolve())
	.then(function (chapter) {
		
		update_progressbar("downloading manifest", dump_progress_bar_retrieve_manifest_max);
		
		$.getJSON(proxy + "statistics/manifest.json", function (json) {

			update_progressbar("downloading resources", dump_progress_bar_retrieve_site_max);
			var promise;
			var c = 0;
			$.each(json.resources, function (i, v) {
				if (promise == undefined) promise = get(v, zip, c);
				else promise = promise.then(function () { return get(v, zip, c) });
			});

			promise.then(function (zip) {
				
				//console.debug(c+" generate constants..");
				zip.file("js/constants.js",
					"var export_interval='<h5>Available interval :</h5>" +
					new Date(read_start_date()) + " - " + new Date(read_end_date()) + "';"
					+ "var ending_info = '/descriptor.json'; var hide_query = true;");

				update_progressbar("building package", dump_progress_bar_building_package_max);
				//console.debug("generate zip..");
				zip.generateAsync({ type: "blob" })
					.then(function (blob) {
						saveAs(blob, "download.zip");
						update_progressbar("completed", dump_progress_bar_completed_max);
					});
			});
			//$.ajaxSetup({async: true});

			terminate_progressbar();
		});
		console.debug("finish!");
	});
};

function test() {
    url = "device/statistics/system/data?startTime=1492162749&endTime=1493890749&resolutionTime=1800"
    new Promise(function (a, b) { $.get(url, function (d) { a(d) }) }).then(function () { return new Promise(function (a, b) { $.get(url, function (d) { a(d) }) }) }).then(function () { return new Promise(function (a, b) { $.get(url, function (d) { a(d) }) }) })
    $.get(url, function (d) { console.debug("first") }).then(function (data) { return $.get(url, function (d) { console.debug(1) }) })
}

var ongoing_promises = 0;

function start_progressbar()
{
	dump_descriptors_count = 0;
	dump_data_count = 0;
	dump_data_downloaded = 0;

    $('#dumpAllButton').css('background-color', '#CCCCCC').attr('onclick', 'javascript:void(0)"');
    $('#queryButton').css('background-color', '#CCCCCC').attr('onclick', 'javascript:void(0)"');
	d3.select('#buttons-row').style('display', 'none');
	d3.select('#progressbar-row').style('display', 'block');
	d3.select('#dump-progressbar').text("0%")
		.attr("aria-valuenow", 0)
		.attr('value', 0)
		.style("width", "0%")
		.classed("progress-bar-info", true)
		.classed("progress-bar-success", false)
}

function update_progressbar(bar_text, bar_val)
{
		if (bar_val == 100)
		{
			d3.select('#dump-progressbar').text(bar_val + "% " + bar_text)
				.attr("aria-valuenow", bar_val)
				.attr('value', bar_val)
				.style("width", bar_val + "%")
				.classed("progress-bar-info", false)
				.classed("progress-bar-success", true)
		}
		else
		{
			d3.select('#dump-progressbar').text(bar_val + "% " + bar_text)
				.attr("aria-valuenow", bar_val)
				.attr('value', bar_val)
				.style("width", bar_val + "%")
				.classed("progress-bar-info", true)
				.classed("progress-bar-success", false)
		}
}

function terminate_progressbar()
{
	setTimeout(function () {
		$('#dumpAllButton').css('background-color', '#0168b3').attr('onclick', 'javascript:dumpAll()');
		$('#queryButton').css('background-color', '#0168b3').attr('onclick', 'javascript:query()');
		d3.select('#buttons-row').style('display', 'block');
		d3.select('#progressbar-row').style('display', 'none');
		d3.select('#dump-progressbar').text("0%")
			.attr("aria-valuenow", 0)
			.attr('value', 0)
			.classed("progress-bar-info", true)
			.classed("progress-bar-success", false)
			.style("width", "0%")}, 1500);
}

var dump_progress_bar_retrieve_info_max = 5;
var dump_progress_bar_retrieve_data_max = 96;
var dump_progress_bar_retrieve_manifest_max = 97;
var dump_progress_bar_retrieve_site_max = 98;
var dump_progress_bar_building_package_max = 99;
var dump_progress_bar_completed_max = 100;
var dump_descriptors_count = 0;
var dump_data_count = 0;
var dump_data_downloaded = 0;

function dump(zip, path, dp) {

	ongoing_promises++;

	update_progressbar("downloading descriptors (" + ongoing_promises + ")", dump_progress_bar_retrieve_info_max);
	
    var promise = new Promise(function (resolve, reject) {
		var json_returned = $.getJSON(path, function (json) {

			console.debug("managing: " + path);

			path = (path.startsWith("/") ? path : "/" + path);

			var path_for_descriptor = (path.endsWith("/") ? path : path + "/").substring(1);
			zip.file(path_for_descriptor + "descriptor.json", JSON.stringify(json));

			descriptor = json;

			if (!!json.data) {
						var param = new Object();
						param.startTime = read_start_date();
						param.endTime = read_end_date();
						param.resolutionTime = $('#resolution-id').val();

						param.uri = path + "/data"
						dp.push(param)

					}

			if (!!json.resources) {
				$.each(json.resources, function (i, v) {
							var id = v.id === undefined ? v : v.id;
							dump(zip, path + "/" + id, dp)
						})
					}

		});
		resolve(json_returned);
    });

    promise.then(
		function (result) {
			console.debug("Resolved (" + dp.length + ")."); 
			ongoing_promises--;
			if (ongoing_promises == 0)
			{
				console.debug("Resolved all (" + dp.length + ")."); 
				build_zip_from_jsons(zip, dp);
			}
		},
		function (err) {
			console.debug("NOOO!: " + err); 
			ongoing_promises--;
		}
	);
}


var inspect_address = "";

/**
 * consume the data from a specific path
 */
function dataConsume(path, json, autoGetData) {
    lastUrl = path;
    lastJson = json;
    if (json.data === undefined) //skip consume if parameter is missing
    {
        d3.select('#queryButton').style("background-color", '#bbb');
        return;
    }

    d3.select('#queryButton').style("background-color", '#0168b3');

    if (!autoGetData)
        return;

    var param = new Object();
    param.startTime = json.data.start;
    param.endTime = json.data.end;
    param.resolutionTime = $('#resolution-id').val();
    //param.compression=json.data.compression

    inspect_address = path + "?startTime=" + param.startTime + "&endTime=" + param.endTime + "&resolutionTime=" + param.resolutionTime;

    var location = window.location.href;
    var directoryPath = location.substring(0, location.lastIndexOf("/") + 1);

    $.get(/*directoryPath + */inspect_address, param, function (data) {
        //console.debug(data);
        if (!!data)
        {
            var sd = new Date(0);
            sd.setUTCSeconds(param.startTime);
            var ed = new Date(0);
            ed.setUTCSeconds(param.endTime);

            $('#current_query').html(inspect_address);
            $("#export_interval_span").html(sd.toUTCString() + "&emsp;&emsp;-&emsp;&emsp;" + ed.toUTCString() + "&emsp;&emsp;&emsp;&emsp;(Resolution: " + param.resolutionTime + " sec)");
            parse(data, json);
        }
    });

}

function read_start_date() {

    return $('#from_date').data("DateTimePicker").date().unix();

    //var date_component = +getDate($("#from_date")).getTime();
    //if (date_component == null)
    //    return 0;
    //var time_component = +getTime($("#from_time")).getTime() - date_component;
    //if (time_component == null)
    //    return 0;
    //return (date_component + time_component) / 1000;
}

function read_end_date() {
    return $('#to_date').data("DateTimePicker").date().unix();

    //var date_component = +getDate($("#to_date")).getTime();
    //if (date_component == null)
    //    return 0;
    //var time_component = +getTime($("#to_time")).getTime() - date_component;
    //if (time_component == null)
    //    return 0;
    //return (date_component + time_component) / 1000;
}

function query() {
    var jsonCopy = new Object(lastJson);
    if (jsonCopy.data) {
        jsonCopy.data.start = read_start_date();
        jsonCopy.data.end = read_end_date();
    }
    dataConsume(lastUrl, jsonCopy, true);
}


function reset(ids) {
    $.each(ids, function (i, id) {
        $(id).find("option").remove();
        $(id + "_name").text("");
        $(id).hide("slow");
        $(id + "_name").hide("slow");
    });//end each
}

function ellipse(str) {
    return str.length > 22 ? str.substr(0, 22) + " .." : str;
}

var choose_value_str = "Choose value ..";
function optionFiller(id, json) {
    if (!!json.resources) {
        $(id).find("option").remove();
        $(id).append($('<option>', { value: "", text: choose_value_str }));
        //$(id+"_name").text(ellipse(json.name));
        $(id).show("slow");
        //$(id+"_name").show( "slow" );


        $.each(json.resources, function (i, v) {
            $(id).append($('<option>', { value: v.id, text: !!v.name ? v.name : v.id }));
        });//end each	
    }
}


var selection, level_0, level_1, level_2, level_3, level_4;
var lastUrl, lastJson;

function build_clean_url(str_selection, str_level) {
    var url = proxy + "device/statistics";
    if (!str_selection.startsWith("/")) {
        url += "/";
    }
    url += str_selection + "/" + str_level;

    if (str_level.length > 0) {
        url += "/";
    }

    return url;
}

var firsttime = true;
function eventChangeSetup() {
	
	function manage_level_change(value, level_num)
	{
		var url = "";
		
		//if (value === choose_value_str )
		reset_level = level_num;
		if (value === "")
			reset_level--;
		
		switch (reset_level)
		{
			case -1:
				reset(["#level_0", "#level_1", "#level_2", "#level_3", "#level_4"]);
				break;
			case 0:
				reset(["#level_1", "#level_2", "#level_3", "#level_4"]);
				break;
			case 1:
				reset(["#level_2", "#level_3", "#level_4"]);
				break;
			case 2:
				reset(["#level_3", "#level_4"]);
				break;
			case 3:
				reset(["#level_4"]);
				break;
			case 4:
				break;
			default:
				return;
		}
		
		switch (level_num)
		{
			case -1:
				selection = value;
				url = build_clean_url(selection, "");
				break;
			case 0:
				level_0 = value;
				url = build_clean_url(selection, level_0);
				break;
			case 1:
				level_1 = value;
				url = build_clean_url(selection, level_0 + "/" + level_1);
				break;
			case 2:
				level_2 = value;
				url = build_clean_url(selection, level_0 + "/" + level_1 + "/" + level_2);
				break;
			case 3:
				level_3 = value;
				url = build_clean_url(selection, level_0 + "/" + level_1 + "/" + level_2 + "/" + level_3);
				break;
			case 4:
				level_4 = value;
				url = build_clean_url(selection, level_0 + "/" + level_1 + "/" + level_2 + "/" + level_3 + "/" + level_4);
				break;
			default:
				return;
		}
		
		
		$.getJSON(url + ending_info, function (json) {
            console.debug(url + ending_info + " : ", json);
            optionFiller("#level_" + (parseInt(level_num) + 1), json);
            var autoquery = hide_query;
            if (!lastJson)
                lastJson = json;

            dataConsume(url + "data", json, firsttime || hide_query);
            firsttime = false;
        });	//end getJson
	}
	
    $("#available_statistics_branches").change(function (e) {
		manage_level_change($(this).val(), -1);
	});//on change
	
    $("#available_statistics_branches").val('system').trigger('change');
    //$("#available_statistics_branches").val('usage').trigger('change');

    $("#level_0").change(function (e) {
        manage_level_change($(this).val(), 0);
    });//on change		

    $("#level_1").change(function (e) {
        manage_level_change($(this).val(), 1);
    });//on change	
	
    $("#level_2").change(function (e) {
        manage_level_change($(this).val(), 2);
    });//on change	
	
    $("#level_3").change(function (e) {
        manage_level_change($(this).val(), 3);	
    });//on change			
	
    $("#level_4").change(function (e) {
		manage_level_change($(this).val(), 4);
    });//on change					
}

function getDate(element) {
    var date;
    try {
        var date_str = element.val();
        date = $.datepicker.parseDate("mm/dd/yy", date_str);
    } catch (error) {
        date = null;
    }

    return date;
}

function getTime(element) {
    try {
        var date_str = element.val();

        var time = date_str.match(/(\d?\d):?(\d?\d?)/);
        var h = parseInt(time[1], 10);
        var m = parseInt(time[2], 10) || 0;

        if (h > 24) {
            // try a different format
            time = text.match(/(\d)(\d?\d?)/);
            h = parseInt(time[1], 10);
            m = parseInt(time[2], 10) || 0;
        }

        var date = new Date();
        date.setHours(h);
        date.setMinutes(m);
        return date;
    } catch (error) {
        return null;
    }
}

/**Decode base64 into a readable string*/
function b64DecodeUnicode(str) {
    return decodeURIComponent(Array.prototype.map.call(atob(str), function (c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    }).join(''));
}

function download() {
    d3.select("*").remove();
    $.get("/data", function (data) {
        parse(data);
    })
}

function downloadEnter() {
	d3.select('#whiteLayer')
		.style("background-color", 'white')
		.style("filter", 'alpha(opacity=25)') /* IE */
		.style("opacity", '0.25') /* Mozilla, Chrome */
		.style("-moz-opacity", '0.25') /* Safari, Opera */
}

function downloadLeave() {
	d3.select('#whiteLayer')
		.style("background-color", 'transparent')
		.style("filter", 'alpha(opacity=100)') /* IE */
		.style("opacity", '1.0') /* Mozilla, Chrome */
		.style("-moz-opacity", '1.0') /* Safari, Opera */
}

function getFormattedDate(d) {
    var month = String(d.getMonth() + 1);
    var day = String(d.getDate());
    var year = String(d.getFullYear());

    if (month.length < 2) month = '0' + month;
    if (day.length < 2) day = '0' + day;

    return month + "/" + day + "/" + year;
}

function init_timeselector() {

    if (hide_query)
        return;

//    // eternicode lib - Apache 2.0 license
//    // initialize input widgets first
//    $('#timepickercontainer .time').timepicker({
//        'showDuration': false,
//        //'timeFormat': 'g:ia',
//        'timeFormat': 'G:i',
//        'options': 'show2400',
//		'setDate': new Date(),
//    });

//    $('#timepickercontainer .date').datepicker({
//        'format': 'mm/dd/yyyy',
//        'autoclose': true,
//        //'setDate': new Date(),
//    });

//    $("#from_date").val(getFormattedDate(new Date()));
//    $("#to_date").val(getFormattedDate((new Date(new Date().getTime() + 24 * 60 * 60 * 1000))));
//    $("#from_time").val("0:00");
//    $("#to_time").val("0:00");  
//// initialize datepair
//    var basicExampleEl = document.getElementById('timepickercontainer');
//    var datepair = new Datepair(basicExampleEl);

    // Eonasdan lib - MIT license
    $('#from_date').datetimepicker({
        stepping: 30,
        format: "DD/MM/YYYY LT",
        useStrict: true,
    });
    $('#to_date').datetimepicker({
        useCurrent: false, //Important! See issue #1075
        stepping: 30,
        format: "DD/MM/YYYY LT",
        useStrict: true,
    });
    $("#from_date").on("dp.change", function (e) {
        $('#to_date').data("DateTimePicker").minDate(e.date);
    });
    $("#to_date").on("dp.change", function (e) {
        $('#from_date').data("DateTimePicker").maxDate(e.date);
    });

	var date_now = new Date();
	date_now.setUTCSeconds(0, 0);
    $('#from_date').data("DateTimePicker").date(new Date(date_now.getTime() - 24 * 60 * 60 * 1000));
    $('#to_date').data("DateTimePicker").date(date_now);
}


/* Mangle data, intersect average with standard deviation anc create multiple graphs */
function parse(data, json) {
    d3.selectAll("svg > *").remove();    //clean up previous render 
    $("#lastQueryDescription").empty();
    var _run = 1; // colonna base per i quartetti avg,std,min,max: inizializzata a 1 per saltare il timestamp

    var tmp = data.split("\n");
    if (!tmp[tmp.length])
        tmp.pop();

    // in salva in tmp il risultato dell'applicazione su ogni elemento di tmp stesso della funzione passata alla chiamata "map", in questo modo tmp da array diventa una matrice bidimensionale
    tmp = tmp.map(function (str) {
        return str.split(",");
    });

    var xRange = [+tmp[0][0] * 1000, +tmp[tmp.length - 1][0] * 1000];
    var _gId = 0;

    // per ogni attribute (alcuni multi-colonna altri no) --> quindi per ogni grafico...
    $.each(json.data.attributes, function (i, v) {

        var header = ["Time"];
        var _avgIdx = -1;
        var parsed = [];

        var groupName = v.name.split("_").join(" ");

        if (!v.columns) {
            //no columns are defined
            if (v.name != "epoch")
                $("#lastQueryDescription").append("<li>" + v.name.replace("_", " ") + " : " + tmp[0] + "x" + v.multiplier + " " + v.unit + "</li>");
        } else {

            // per ogni colonna dell'attribute corrente
            $.each(v.columns, function (ii, vv) {

                header.push(vv);

                if (vv == "avg") {
                    // avg: salva l'indice
                    _avgIdx = ii;
                }

                if (vv == "std" && _avgIdx != -1) {
                    // std: caso particolare--> costruisce 2 valori: avg+std e avg-std

                    // avg+std
                    var statsUp = {
                        id: "avg+std",
                        // salva in values il risultato dell'applicazione su tmp della funzione sotto: ogni elemento di values contiene...
                        values: tmp.map(function (d) {
                            return {
                                time: new Date(+d[0] * 1000), // ...un membro "time" a cui  passato l'elemento in posizione [0] fissa dell'elemento corrente di tmp (in pratica tmp[i][0]) (moltiplicato per 1000 per avere il valore in ms) 
                                value: parseFloat(d[_avgIdx + _run]) + parseFloat(d[ii + _run]) // ...e in value viene salvato invece il valore dato dalla somma della media (colonna trovata sommando lo spiazzamento del quartetto "_run" alla posizione della colonna "avg" nel quartetto) + il valore della deviazione standard (colonna trovata sommando lo spiazzamento del quartetto "_run" alla posizione della colonna "std" nel quartetto)
                            };
                        })
                    };
                    parsed.push(statsUp);

                    // avg+std: valgono i commenti sopra
                    var statsLow = {
                        id: "avg-std",
                        values: tmp.map(function (d) {
                            return {
                                time: new Date(+d[0] * 1000),
                                value: parseFloat(d[_avgIdx + _run]) - parseFloat(d[ii + _run])
                            };
                        })
                    };
                    parsed.push(statsLow);

                } else {
                    // avg, min e max: vale lo stesso principio spiegato per la generazione della variabile statsUp
                    var stats = {
                        id: vv,
                        values: tmp.map(function (d) {
                            return {
                                time: new Date(+d[0] * 1000),
                                value: d[ii + _run]
                            };
                        })
                    };
                    parsed.push(stats);

                }
            })	//end each columns

            // a questo punto in "parsed" e' un array di elementi con "id" (contenente il nome della serie) e values (i dati della serie stessa in forma di array di coppie <time;value>)

            //for(let i of stats) console.debug(i);

            // renderizza il l'attribute corrente (quartetto) in un chart
            render(xRange, parsed, _gId, groupName.toUpperCase() + " ( " + (v.multiplier > 1 ? v.multiplier + " " : "") + v.unit + " )");

            // prepara i valori per l'attribute (cioe' il quartetto e cioe' il grafico) successivo
            _gId++;
            _run += v.columns.length;
        }
    });//end eachattributes

    for (var i = 0; i < _gId; ++i) {
        $('#g' + i).show();
        $('#divg' + i).show();

    }
    for (var i = _gId; i < 6; ++i) {
        $('#g' + i).hide();
        $('#divg' + i).hide();
    }
}

function z(d) {
    if (!d) return "00"
    else return d;
}

var palette = {
    counter: 0,
    map: new Map(),
    //colors: d3.schemeCategory10, // v4
    colors: d3.scale.category10(), // v3

    get: function (o) {
        var r = this.map.get(o);
        if (!r) {

            // enable custum color map
            //this.map.set("min","#D62728")
            //this.map.set("max","#9467BD")
            //this.map.set("avg",    "#FF7F0E")
            //this.map.set("avg+std","#2CA02C")
            //this.map.set("avg-std","#1F77B4")
            //r = this.map.get(o);
            //if (!r){

            // - v4 --------------------------
            //r = this.colors[];
            //var l = this.colors.length();
            // - v3 --------------------------
            var m = this.colors.range();
            var s = d3.scale.ordinal().range(m);
            var l = m.length;
            for (var i = 0; i < l; i++) {
                this.colors(i);
            }
            // - -- --------------------------

            r = this.colors(this.counter++ % l);

            this.map.set(o, r);
            //}
        }
        return r;
    }
}

function open_inspect()
{
    window.open(inspect_address);
    //location.href = inspect_address;
}

jQuery.ajaxSetup({
    beforeSend: function () {
		if (d3.select('#progressbar-row').style('display') == 'none')
		{
			$('#loader').show();
		}
    },
    complete: function () {
        $('#loader').hide();
    },
    success: function (data) {
        console.log("ajax success");
    },
    error: function (jqXHR, textStatus, errorThrown) {
        console.log("ajax error: " + textStatus);
    }
});
